/*
pid.hh

This C++ header file defines the class PID_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
12-Sep-99	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef PID_HH
#define PID_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "pid_ctrl.hh" 	// PID_CTRL definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "pidn.hh" 	// NML Commands and Status definitions for pid
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class PID_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	PID_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(PID_INIT *);
	virtual void HALT(PID_HALT *);
	virtual void RUN(PID_RUN *);
	virtual void SET_GAINS(PID_SET_GAINS *);

	// Convenience Variables
	PID_STATUS *pid_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
  PID_CTRL *pid_ctrl;
  double plant_output;
  double ctrl_output;

};

#endif 	// PID_HH

